(function(window, undefined){
	"use strict";

var Ease = function(target, time, properties, endCallback)
{
	this.target = target;
	this.time = time;
	this.properties = properties;
	this.endCallback = endCallback;
	
	this.base_properties = {};
	this.current_time = 0;
	
	this.is_end = false;
	
	this._init_base_properties();
};
Ease.prototype._init_base_properties = function()
{
	this.base_properties = {};
	for (var k in this.properties)
	{
		this.base_properties[k] = this.target[k];
	}
};
/*Ease.prototype.set_target = function(target)
{
	for (var k in target)
	{
		if (this.target[k] === undefined)
		{
			this.target[k] = target[k];
		}
	}
	this._init_base_properties();
};*/
Ease.prototype.update = function(delta)
{
	this.current_time += delta;
	
	if (this.current_time < this.time)
	{
		var new_val;
		for (var k in this.properties)
		{
			new_val = this.compute_val(
				(this.properties[k] - this.base_properties[k]),
				(this.current_time / this.time)
			);
			this.target[k] = this.base_properties[k] + new_val;
		}
	}
	else if (!this.is_end)
	{
		for (var k in this.properties)
		{
			this.target[k] = this.properties[k];
		}
		
		this.is_end = true;
		if (this.endCallback)
		{
			this.endCallback();
		}
	}
};
Ease.prototype.compute_val = function (val, percent)
{
	return val * this.linear(percent);
};
Ease.prototype.linear = function (x)
{
	return x;
};

window.Ease = Ease;

})(window);
