(function(window, undefined){
    "use strict";

window.ads = {
    is_init: false,
    banner_key: null
};

window.ads.init = function(banner_key)
{
    if (window.AdMob)
    {
        window.ads.banner_key = banner_key;

        try {
            AdMob.createBanner({
                adId: window.ads.banner_key,
                position: AdMob.AD_POSITION.TOP_CENTER,
                autoShow: false });

            document.addEventListener('onAdFailLoad', function(e){
                window.ads.is_init = false;
                console.log("onAdFailLoad", e);
            });

            window.ads.is_init = true;
        } catch (e) {
            console.log("Error while loading admob module", e);
        }
    }
    else
    {
        console.log("Could not load admobAd module");
    }
};

window.ads.show_banner = function()
{
    if (window.ads.is_init)
    {
        try
        {
            if (window.AdMob)
                AdMob.showBanner(AdMob.AD_POSITION.TOP_CENTER);
        }
        catch (e)
        {
            console.debug("Could not show ads", e);
        }
    }
    else
    {
        console.log("Can't show ads, ads are not init");
    }

};

window.ads.hide_banner = function()
{
    try
    {
        if (window.AdMob)
            AdMob.hideBanner();
    }
    catch (e)
    {
        console.debug("Could not hide ads", e);
    }
};


})(window);
