(function(window, undefined){
    "use strict";

window._analytics = {
    app_name: null,
    track_code: null,
    trackerUrl: 'http://analytics.yetanotherportfolio.fr/piwik.php',
    siteId: 2,
    is_init: false
};

window._analytics.init = function()
{
    if(window._paq !== undefined)
    {
        try {
            window._analytics.piwik = Piwik.getTracker(
                window._analytics.trackerUrl,
                window._analytics.siteId
            );
            
            window._analytics.piwik.trackPageView();
            window._analytics.is_init = true;
        } catch(err)
        { console.log("Error while loading analytics", err); }
    }
    else
    { console.log("Could not load analytics module"); }
};

//@see https://developers.google.com/analytics/devguides/collection/gajs/eventTrackerGuide
window._analytics.push = function(action, name, value)
{
    var args = [];
    for (var i in arguments)
    {
        args.push(arguments[i]);
    }

    if (arguments.length <= 0 || !_analytics.app_name)
    {
        return;
    }

    if (window._paq !== undefined && window._analytics.is_init)
    {
        try
        {
            //_paq.push(['trackEvent', _analytics.app_name].concat(args));
            //console.log('piwik', ['trackEvent', _analytics.app_name].concat(args));
            
            var category = _analytics.app_name;
            window._analytics.piwik.trackEvent(category, action, name, value);
            console.log('trackEvent ', category, action, name, value);
        }
        catch (err)
        { console.log("Cant do Piwik analytics", err); }
    }
};

})(window);
