(function(window, undefined){
	"use strict";

var events = {
	
	queue: {},
	
	on: function(name, callback)
	{
		if (this.queue[name])
		{
			this.queue[name].push(callback);
		}
		else
		{
			this.queue[name] = [callback];
		}
	},
	emit: function(name, args)
	{
		if (this.queue[name])
		{
			var callback;
			for (var i = 0; i < this.queue[name].length; i++)
			{
				callback = this.queue[name][i];
				callback(args);
			}
		}
		/*else
		{
			console.error("Undefined event", name);
		}*/
	},
	remove: function(name, callback)
	{
		if (this.queue[name] && callback === undefined)
		{
			//delete this.queue[name];
			this.queue[name].length = 0;
		}
		else if (this.queue[name])
		{
			var _callback;
			for (var i = 0; i < this.queue[name].length; i++)
			{
				_callback = this.queue[name][i];
				if(_callback == callback)
				{
					//delete this.queue[name][i];
					this.queue[name].splice(i, 1);
					break;
				}
			}
		}
	}
};

window.events = events;

})(window);
