(function(window, undefined){
    "use strict";

    function move_event(e)
    {
        var offsetX = 0;
        var offsetY = 0;
        if (canvas_elem)
        {
            offsetX = canvas_elem.offsetLeft;
            offsetY = canvas_elem.offsetTop;

            var px = canvas_elem.width / canvas_elem.style_width;
            var py = canvas_elem.height / canvas_elem.style_height;
        }

        var _mouse_pos_x = e.pageX;
        var _mouse_pos_y = e.pageY;
        if (e.touches !== undefined && e.touches.length > 0)
        {
            _mouse_pos_x = e.touches[0].pageX;
            _mouse_pos_y = e.touches[0].pageY;
        }

        mouse.pos.x = (_mouse_pos_x - offsetX) * px;
        mouse.pos.y = (_mouse_pos_y - offsetY) * py;
    }

    function down_event(e)
    {
        move_event(e);
        mouse.pressed = true;
        mouse.is_changing = true;
    }

    function up_event(e)
    {
        move_event(e);
        mouse.pressed = false;
        mouse.is_changing = true;
    }

    window.mouse = {
        pressed: false,
        is_changing: false,
        pos: new Vect()
    };

    window.addEventListener('load', function(e)
    {
        document.addEventListener('mousemove', move_event);
        document.body.addEventListener("mousedown", down_event);
        document.body.addEventListener("mouseup", up_event);

        document.addEventListener('touchmove', move_event);
        document.body.addEventListener("touchstart", down_event);
        document.body.addEventListener("touchend", up_event);
    });
})(window);
