(function(window, undefined){
    "use strict";

var AddLineHint = function(image, group)
{
    Sprite.apply(this, [
        image,
        new Vect(
            canvas_elem.width/2 - image.width/2,
            canvas_elem.height/2 + 30
        )
    ]);

    this.group = group;

    this.alpha = 0;
    this.active = false;
    this.easing = null;
}
AddLineHint.prototype = new Sprite();
AddLineHint.prototype.constructor = Sprite;
AddLineHint.prototype.remove = function(canvas)
{
    this.group.splice(this.group.indexOf(this), 1);
}
AddLineHint.prototype.update = function(delta)
{
    if (this.easing) this.easing.update(delta);

    if (this.active && mouse.pressed && this.alpha > 0 &&
            this.rect.collidePoint(mouse.pos))
    {
        // fake pressing space
        events.emit('keydown 32', null);
        this.active = false;
    }
}

AddLineHint.prototype.show = function()
{
    this.easing = new Ease(this, 500, {alpha:1});
    this.active = true;
};

AddLineHint.prototype.hide = function(deta)
{
    this.easing = new Ease(this, 500, {alpha:0});
    this.active = false;
};

window.AddLineHint = AddLineHint;

})(window);
