(function(window, undefined){
	"use strict";

var Timer = function()
{
	Text.apply(this, [
		'00:00',
		new Rect(new Vect((canvas_elem.width/2)-(22*2), 25))
	]);
	
	this.val = 0;
	this.style.font = '22px sans-serif';
	this.style.fillStyle = '#333';
	
	this.start();
}
Timer.prototype = new Text();
Timer.prototype.constructor = Text;
Timer.prototype.updateTime = function()
{
	this.val += 1000;
	
	var min = Math.floor(this.val/1000/60)+'';
	var sec = Math.floor((this.val/1000) - min*60)+'';
	
	if (min.length == 1) min = '0'+min;
	if (sec.length == 1) sec = '0'+sec;
	
	this.set_text(min+':'+sec);
}
Timer.prototype.start = function()
{
	var self = this;
	this.timer_id = setInterval(
		function(){ self.updateTime.apply(self) },
		1000
	);
}
Timer.prototype.toggle = function(is_pause)
{
	if (!is_pause)
	{
		this.start();
	}
	else
	{
		this.stop();
	}
}
Timer.prototype.stop = function()
{
	clearInterval(this.timer_id);
}

window.Timer = Timer;

})(window);
