(function(window, undefined){
	"use strict";

var AchievementScene = function(manager)
{
	var self = this;
	
	//background
	this.background = new Sprite(manager.get_asset('achievementscene'));
	
	// the play BTN but it go to tuto
	this.playbtn = new Button(
		manager.get_asset('backBtn'),
		new Vect(
			45,
			canvas_elem.height - 90
		),
		function(){self.goto_back.apply(self)}
	);
	
	// list of achievements
	var txt = '';
	var popupOffset = new Vect(25, 30);
	for (var k in AchievementScene.LIST)
	{
		txt += AchievementScene.LIST[k]+'\n'
	}
	this.list = new Text(
		txt,
		new Rect(
			new Vect(popupOffset.x+15, popupOffset.y+15),
			new Vect(0, 24)
		)
	);
	
	this.manager = manager;
}

AchievementScene.LIST = {
	
	'20pts': 'make more than 20 points',
	'40pts': 'make more than 40 points',
	'60pts': 'make more than 60 points',
	'100pts': 'make more than 100 points',
	
	'3color': 'make 3 color bonus in a row',
	'10color': 'make 10 color bonus in a row',
	
	'10row': 'add 10 row before the next line addition',
	
	'2min': 'survive 2 minutes',
	'5min': 'survive 5 minutes',
	'10min': 'survive 10 minutes',
	
	'5cards': 'make a 5 or more cards blackjack',
	'8cards': 'make a 8 or more cards blackjack'
};

AchievementScene.prototype.destroy = function()
{
	this.playbtn.destroy();
};
AchievementScene.prototype.update = function(canvas)
{
};
AchievementScene.prototype.draw = function(canvas)
{
	this.background.draw(canvas);
	this.playbtn.draw(canvas);
	this.list.draw(canvas);
};
AchievementScene.prototype.goto_back = function()
{
	this.manager.change('menu');
	this.manager.get_asset('blip').play();
};

window.AchievementScene = AchievementScene;

})(window);
