(function(window, undefined){
    "use strict";

var TutoScene = function(manager)
{
    this.manager = manager;
    this.drawables = [];

    _analytics.push('startTuto');

    //background
    var background = new Sprite(manager.get_asset('gamescene'));
    this.drawables.push(background);

    //current count
    var currentCount = new Count();
    this.drawables.push(currentCount);

    //score
    var score = new Score();
    this.drawables.push(score);

    //timer
    /*var timer = new Timer();
    this.drawables.push(timer);*/

    //cards
    initCards(this.drawables, currentCount, score/*, timer*/, manager, this);
    //startSpawn();

    this.STEP_FIRST     = 0;
    this.STEP_TOTAL     = 1;
    this.STEP_LOSE      = 2;
    this.STEP_WIN       = 3;

    this.steps = [
        new Sprite(
            manager.get_asset('tuto1'),
            new Vect(
                80,
                100
            )
        ),
        new Sprite(manager.get_asset('tuto2'),
            new Vect(
                10,
                160
            )),
        new Sprite(manager.get_asset('tutoLose'),
            new Vect(
                20,
                210
            )),
        new Sprite(manager.get_asset('tutoWin'),
            new Vect(
                20,
                (canvas_elem.height / 2) - 150
            )
        )
    ];
    this.currentStep = 0;
}
TutoScene.prototype.destroy = function()
{
    destroyCards();
    this.drawables = [];
}
TutoScene.prototype.update = function(delta)
{
    for (var i = 0; i < this.drawables.length; i++)
    {
        this.drawables[i].update(delta);
    }

    this.steps[this.currentStep].update(delta);
};
TutoScene.prototype.draw = function(canvas)
{
    //~ stats.begin();

    for (var i = 0; i < this.drawables.length; i++)
    {
        this.drawables[i].draw(canvas);
    }

    this.steps[this.currentStep].draw(canvas);

    //~ stats.end();
}
TutoScene.prototype.lose = function(canvas)
{
    var score = saveScore();
    this.end_of_game();
    this.manager.change('end', score);
}
TutoScene.prototype.end_of_game = function(canvas)
{
    //events.remove('win', this._win);
    events.remove('lose', this._lose);
}
TutoScene.prototype.nextStep = function(step, next)
{
    if (step === null || this.currentStep == step)
    {
        if (next === undefined)
        {
            this.currentStep += 1;
        }
        else
        {
            this.currentStep = next;
        }

        if (this.currentStep > this.steps.length-1)
        {
            localStorage.setItem(MenuScene.FIRSTTIME_KEY, 0);
            this.currentStep = this.steps.length-1;
            this.manager.change('game');
        }
    }
}

window.TutoScene = TutoScene;

})(window);
