(function(window, undefined){
	"use strict";

var Counter = function(min, max, current)
{
	this.min = min || 0;
	this.max = max || 100
	this.val = current || this.min;
	
	this.test = null;
	this.callback = null;
}
Counter.prototype.on = function(test, callback)
{
	this.test = test;
	this.callback = callback;
}
Counter.prototype.increment = function()
{
	this.set(this.val+1);
}
Counter.prototype.decrement = function()
{
	this.set(this.val-1);
}
Counter.prototype.set = function(_val)
{
	this.val = _val;
	this.val = Math.min(this.val, this.max);
	this.val = Math.max(this.val, this.min);
	
	if (this.test && this.callback && this.test())
	{
		this.callback();
	}
}
Counter.prototype.get = function(_val)
{
	return this.val;
}

window.Counter = Counter;

})(window);
