(function(window, undefined){
	"use strict";

window.Cookies = {
	
	get: function(key)
	{
		var cookies = document.cookie.split(';');
		
		var cookie;
		for (var i = 0; i < cookies.length; i++)
		{
			cookie = cookies[i].split('=');
			if (cookie[0] == key)
			{
				return cookie[1];
			}
		}
		return null;
	},
	
	set: function(key, val, days)
	{
		if (days === undefined || days == null || days == 0)
		{
			days = 360*10;// 10 years
		}
		
		var today = new Date();
		var expire = new Date();
		
		expire.setTime(today.getTime() + 3600000*24*days); 
		
		document.cookie = key+"="+
			escape(val)+
			";expires="+expire.toGMTString();
	}
};

})(window);
