(function(window, undefined){
	"use strict";

var Drawable = function(rect)
{
	this.rect = rect || new Rect();
	this.draw_region = null;
}
Drawable.prototype.draw = function(canvas)
{
	canvas.strokeStyle = "#fff";
	canvas.strokeRect(
		this.rect.pos.x,
		this.rect.pos.y,
		this.rect.size.x,
		this.rect.size.y
	);
	
	/*if (this.draw_region)
	{
		canvas.strokeStyle = "#ff0000";
		canvas.strokeRect(
			this.draw_region.pos.x,
			this.draw_region.pos.y,
			this.draw_region.size.x,
			this.draw_region.size.y
		);
	}*/
}
Drawable.prototype.reshape = function(newShape)
{
	this.draw_region = Rect.merge(this.rect, newShape);
	this.rect = newShape;
	
	//events.emit('paint', this);
}
Drawable.prototype.move = function(x, y)
{
	this.reshape(
		new Rect(
			new Vect(
				this.rect.pos.x+x,
				this.rect.pos.y+y
			),
			new Vect(
				this.rect.size.x,
				this.rect.size.y
			)
		)
	);
}

window.Drawable = Drawable;

})(window);
