(function(window, undefined){
	"use strict";

var Loader = function(assets)
{
	this.assets = assets || [];
	this.is_loaded = false;
	this.nb_loaded = 0;
	this.nb_assets = 0;
	this.end_call;
	this.step_call;
}
Loader.prototype.start = function(end_call, step_call)
{
	this.end_call = end_call;
	this.step_call = step_call;
	
	this.is_loaded = false;
	this.nb_loaded = 0;
	this.nb_assets = 0;
	
	var self = this;
	for (var i in this.assets)
	{
		this.nb_assets += 1;
		
		if (typeof(this.assets[i]) == "string")
		{
			var img = new Image();
			img.addEventListener(
				'load',
				function(){self._onload.apply(self, arguments)}
			);
			img.src = this.assets[i];
			this.assets[i] = img;
		}
		else if (this.assets[i].load !== undefined)
		{
			this.assets[i].load();
			this.assets[i].bind(
				"loadeddata",
				function(){self._onload.apply(self, arguments)
			});
		}
	}
	
	if (this.nb_assets == 0)
	{
		this._load_end();
	}
}
Loader.prototype._onload = function()
{
	this.nb_loaded += 1;
	if (this.nb_loaded >= this.nb_assets)
	{
		this._load_end();
	}
	else if (this.step_call)
	{
		this.step_call();
	}
}
Loader.prototype._load_end = function()
{
	this.is_loaded = true;
	if (this.end_call)
	{
		this.end_call();
	}
}

Loader.prototype.get_percent = function()
{
	return this.nb_loaded / this.nb_assets;
}


window.Loader = Loader;

})(window);
