(function(window, undefined){
	"use strict";

var Rect = function(pos, size)
{
	this.pos = pos || new Vect();
	this.size = size || new Vect();
};
Rect.prototype.collide = function (rect2)
{
	var x1 = (this.pos.x <= rect2.pos.x &&
		this.pos.x + this.size.x >= rect2.pos.x);
	var y1 = (this.pos.y <= rect2.pos.y &&
		this.pos.y + this.size.y >= rect2.pos.y);
	var x2 = (rect2.pos.x <= this.pos.x &&
		rect2.pos.x + rect2.size.x >= this.pos.x);
	var y2 = (rect2.pos.y <= this.pos.y &&
		rect2.pos.y + rect2.size.y >= this.pos.y);
	
	return (x1 || x2) && (y1 || y2);
};
Rect.prototype.collidePoint = function (pt)
{
	return pt.x >= this.pos.x &&
		pt.x <= this.pos.x + this.size.x &&
		pt.y >= this.pos.y &&
		pt.y <= this.pos.y + this.size.y;
},
Rect.merge = function(rect1, rect2)
{
	var x = rect1.pos.x <= rect2.pos.x ? rect1.pos.x : rect2.pos.x;
	var y = rect1.pos.y <= rect2.pos.y ? rect1.pos.y : rect2.pos.y;
	
	var px1 = rect1.pos.x + rect1.size.x;
	var py1 = rect1.pos.y + rect1.size.y;
	
	var px2 = rect2.pos.x + rect2.size.x;
	var py2 = rect2.pos.y + rect2.size.y;
	
	var w = 0;
	var h = 0;
	
	if (px1 > px2)
	{
		w = px1 - x;
	}
	else
	{
		w = px2 - x;
	}
	
	if (py1 > py2)
	{
		h = py1 - y;
	}
	else
	{
		h = py2 - y;
	}
	
	return new Rect(
		new Vect(x, y),
		new Vect(w, h)
	);
}

window.Rect = Rect;

})(window);
