(function(window, undefined){
	"use strict";

var Text = function(str, rect)
{
	if (!rect)
	{
		rect = new Rect(
			new Vect(),
			new Vect(0, 12)
		);
	}
	
	Drawable.apply(this, [rect]);
	
	this.set_text(str);
	this.style = {fillStyle: '#000', /*lineWidth:1,*/ font: rect.size.y+'px sans-serif'};
}
Text.prototype = new Drawable();
Text.prototype.constructor = Drawable;
Text.prototype.set_text = function(str)
{
	if (str && str.split !== undefined)
	{
		this._str = str.split("\n");
	}
	else if (str !== null && str !== undefined)
	{
		this._str = [str];
	}
	else
	{
		this._str = [];
	}
}
Text.prototype.update = function(delta){};
Text.prototype.draw = function(canvas)
{
	canvas.save();
	
	var s;
	for (s in this.style)
	{
		canvas[s] = this.style[s];
	}
	
	/*if (this.type == this.TYPE_FILL)
	{*/
	
	for (var i = 0; i < this._str.length; i++)
	{
		//console.log(this._str[i], this.rect.pos.x, this.rect.pos.y + this.rect.size.y*i)
		canvas.fillText(this._str[i], this.rect.pos.x, this.rect.pos.y + this.rect.size.y*i);
	}
	/*}
	else
	{
		canvas.strokeText(this.text, this.pos.x, this.pos.y);
	}*/
	
	canvas.restore();
}

window.Text = Text;

})(window);
