(function(window, undefined){
    "use strict";

window._analytics = {
    app_name: null,
    track_code: null,
    is_init: false
};

window._analytics.init = function()
{
    if (window.analytics !== undefined)
        window.analytics.startTrackerWithId(_analytics.track_code);

    if (window.gaPlugin)
    {
        window.gaPlugin.init(
            function(){},
            function(){},
            _analytics.track_code, 10
        );
        window._analytics.is_init = true;
    }
    else
    {
        console.log("Could not load gaPlugin module");
    }

};

//@see https://developers.google.com/analytics/devguides/collection/gajs/eventTrackerGuide
window._analytics.push = function()
{
    var args = [];
    for (var i in arguments)
    {
        args.push(arguments[i]);
    }

    if (arguments.length <= 0 || !_analytics.app_name)
    {
        return;
    }

    if (window.gaPlugin)
    {
        // (success, fail, category, eventAction, eventLabel, eventValue)
        var _args = [
            "null",
            "null",
            "null",
            0
        ];
        if (args[0] !== undefined) _args[0] = args[0];
        if (args[1] !== undefined) _args[1] = args[1];
        if (args[2] !== undefined) _args[2] = args[2];
        if (args[3] !== undefined) _args[3] = args[3];

        window.gaPlugin.trackEvent.apply(
            this,
            [
                function(){},
                function(){},
            ].concat(_args)
        );
    }
    if (window.ga !== undefined)
    {
        try
        {
            ga.apply(this, ['send', 'event'].concat(args));
            console.log('ga', ['send', 'event'].concat(args));
            //~ ga.push(['_trackEvent', analytics.app_name].concat(args));
            //~ console.log(['_trackEvent', analytics.app_name].concat(args));
        }
        catch (err)
        { console.log("Cant do Google analytics", err); }
    }
    if (window._paq !== undefined)
    {
        try
        {
            _paq.push(['trackEvent', analytics.app_name].concat(args));
            console.log('piwik', ['trackEvent', analytics.app_name].concat(args));
        }
        catch (err)
        { console.log("Cant do Piwik analytics", err); }
    }
};

})(window);
