(function(window, undefined){
    "use strict";

var Coin = function(image, group)
{
    Sprite.apply(this, [
        image,
        new Vect(
            mouse.pos.x,
            mouse.pos.y
        )
    ]);

    var rx = (Math.random() * Coin.RANDOM_X) - (Coin.RANDOM_X / 2);
    var ry = (Math.random() * Coin.RANDOM_Y) - (Coin.RANDOM_Y / 2);
    if (rx < 0) rx -= this.rect.size.x;
    if (ry < 0) ry -= this.rect.size.y;
    this.rect.pos.x += rx;
    this.rect.pos.y += ry;

    var a = Math.atan2(
        mouse.pos.y - 25,
        mouse.pos.x - canvas_elem.width-25-75
    );
    this.vx = Math.cos(a) * Coin.SPEED;
    this.vy = Math.sin(a) * Coin.SPEED;

    this.group = group;
    var self = this;
    this.easing = new Ease(
        this, Coin.TIME,
        {
            alpha: 0
        },
        function()
        {
            self.remove.apply(self);
        }
    );
}
Coin.TIME = 900; // in ms
Coin.RANDOM_X = 35;
Coin.RANDOM_Y = 35;
Coin.SPEED = 2.3;


Coin.prototype = new Sprite();
Coin.prototype.constructor = Sprite;
Coin.prototype.remove = function(canvas)
{
    this.group.splice(this.group.indexOf(this), 1);
}
Coin.prototype.update = function(delta)
{
    if (this.easing)
    {
        this.easing.update(delta);

        this.rect.pos.x -= this.vx;
        this.rect.pos.y -= this.vy;
    }
}

window.Coin = Coin;

})(window);
