(function(window, undefined){
    "use strict";

var ColorBonus = function(image, group)
{
    Sprite.apply(this, [
        image,
        new Vect(
            mouse.pos.x,
            mouse.pos.y
        )
    ]);

    this.group = group;

    var self = this;
    this.easing = new Ease(this, ColorBonus.TIME, {alpha:0}, function()
    {
        self.remove.apply(self);
    });
}
ColorBonus.TIME = 1200; // in ms
ColorBonus.prototype = new Sprite();
ColorBonus.prototype.constructor = Sprite;
ColorBonus.prototype.remove = function(canvas)
{
    this.group.splice(this.group.indexOf(this), 1);
}
ColorBonus.prototype.update = function(delta)
{
    if (this.easing) this.easing.update(delta);

    //Sprite.prototype.draw.apply(this, [canvas]);
}

window.ColorBonus = ColorBonus;

})(window);
