(function(window, undefined){
    "use strict";

window.canvas_elem = null;
var canvas = null;

//~ window.stats = new Stats();

var scenemanager;

window.kongregate = null;

function initApi()
{
    // Called when the API is finished loading
    function onLoadCompleted(){
        // Get a global reference to the kongregate API. This way, pages included in the
        // iframe can access it by using "parent.kongregate"
        kongregate = kongregateAPI.getAPI();

        // Embed the game into the "contentdiv" div, which is defined below. You can also
        // manually create your own iframe, this function is just for convenience.
        // This example also passes along the kongregate user_id and game_auth_token so
        // that the page can use them for authentication.
        /*var params = "kongregate_user_id=" + kongregate.services.getUserId() +
            "&kongregate_game_auth_token=" + kongregate.services.getGameAuthToken() +
            "&random=" + (Math.random() * 1000000000);

        kongregateAPI.embedFrame("game.html?" + params);*/

        init2();
    }

    // Begin the process of loading the Kongregate API:
    kongregateAPI.loadAPI(onLoadCompleted);
}

function init2()
{
    //analytics
    _analytics.app_name = 'MathJack';
    _analytics.track_code = 'UA-3229596-7';

    canvas_elem = document.getElementsByTagName("canvas")[0];
    canvas = canvas_elem.getContext("2d");

    var width = window.innerWidth;
    var height = window.innerHeight;
    var dips = window.devicePixelRatio;
    dips = 1.0;

    var ratio = 480.0 / 640.0;
    if (width < height)
    {
        //~ width = height * ratio;
        height = width / ratio;
    }
    else if (width >= height)
    {
        width = height * ratio;
    }

    canvas_elem.style_width = (dips * width)- 5;
    canvas_elem.style_height = (dips * height) - 5;
    canvas_elem.style.width = canvas_elem.style_width + "px";
    canvas_elem.style.height = canvas_elem.style_height + "px";

    canvas_elem.style['margin-left'] = (
        (window.innerWidth - canvas_elem.style_width)/ 2)   + "px";
    canvas_elem.style['margin-top'] = (
        (window.innerHeight - canvas_elem.style_height) / 2) + "px";

    scenemanager = new SceneManager({
        preloader: PreLoader,
        menu: MenuScene,
        //~ achievement: AchievementScene,
        game: GameScene,
        tuto: TutoScene,
        end: EndScene
    }, canvas);
    scenemanager.start(canvas, 'preloader', {
        //backgrounds
        menuscene: 'image/menuscene.png',
        //~ achievementscene: 'image/achievementscene.png',
        gamescene: 'image/gamescene.png',
        endscene: 'image/endscene.png',

        //menu
        bigTitle: 'image/bigTitle.png',
        creditsBtn: 'image/creditsBtn.png',
        credits: 'image/credits.png',
        playBtn: 'image/playBtn.png',
        tutoBtn: 'image/tutoBtn.png',

        //achievement
        //~ backBtn: 'image//backBtn.png',

        //game
        cards: 'image/cards.png',
        colorbonus: 'image/colorbonus.png',
        coin: 'image/coin.png',
        pause: 'image/pause.png',
        bad: 'image/bad.png',
        addLine: 'image/addLine.png',
        gauge: 'image/gauge.png',

        //tuto
        tuto1: 'image/tuto1.png',
        tuto2: 'image/tuto2.png',
        tutoLose: 'image/tutoLose.png',
        tutoWin: 'image/tutoWin.png',

        //sounds
        blip: new buzz.sound("sound/card", {
                formats: [ "ogg", "mp3"/*, "aac", "wav"*/ ]
            }),
        positive: new buzz.sound("sound/chips", {
                formats: [ "ogg", "mp3"/*, "aac", "wav"*/ ],
                volume: 37
            }),
        explode: new buzz.sound("sound/explode", {
                formats: [ "ogg", "mp3"/*, "aac", "wav"*/ ]
            })
    });

    //set update
    //events.on('render', update);
    //setInterval(function(){events.emit('render');}, 1000/60);
}

document.addEventListener("app.Ready", init2, false);

//window.drawables = drawables;
})(window);
