(function(window, undefined){
	"use strict";

var PreLoader = function(manager)
{
	this.manager = manager;
	
	this.loading = new Text(
		'loading: 0%',
		new Rect(
			new Vect(canvas_elem.width/2 - 60, canvas_elem.height/2 - 10),
			new Vect(0, 18)
		)
	);
	var self = this;
	this.manager.loader.start(
		function(){self.goto_menu.apply(self)}
	);
}
PreLoader.prototype.destroy = function()
{
	
}
PreLoader.prototype.update = function(canvas)
{
	this.loading.set_text('loading: ' + Math.round(this.manager.loader.get_percent()*100) + '%');
}
PreLoader.prototype.draw = function(canvas)
{
	this.loading.draw(canvas);
	
	canvas.fillStyle = '#eee';
	canvas.fillRect(canvas_elem.width/2 - 60, canvas_elem.height/2 + 2, this.manager.loader.get_percent()*110, 10);
	
	canvas.strokeStyle = '#fff';
	canvas.strokeRect(canvas_elem.width/2 - 60, canvas_elem.height/2 + 2, 110, 10);
}
PreLoader.prototype.goto_menu = function()
{
	this.manager.change('menu');
}

window.PreLoader = PreLoader;

})(window);
